about summary refs log tree commit homepage
path: root/t/t0030-fast-pipe-response.sh
diff options
context:
space:
mode:
authorEric Wong <normalperson@yhbt.net>2010-07-19 10:09:53 +0000
committerEric Wong <normalperson@yhbt.net>2010-07-19 17:04:23 -0700
commit549b25fd501b0df4a4a8b5edccde6101edb0cd63 (patch)
treed0ba43edb1b6ca84a4f89207dcc7397e57c3a9c8 /t/t0030-fast-pipe-response.sh
parent12205e29b29f844295d1794bfe10634646541f20 (diff)
downloadrainbows-549b25fd501b0df4a4a8b5edccde6101edb0cd63.tar.gz
Using EM.enable_proxy with EM.attach seems to cause
EM::Connection#receive_data callbacks to be fired before the
proxy has a chance to act, leading the first few chunks of data
being lost in the default receive_data handler.  Instead
just rely on EM.watch like the chunked pipe.
Diffstat (limited to 't/t0030-fast-pipe-response.sh')
-rwxr-xr-xt/t0030-fast-pipe-response.sh36
1 files changed, 36 insertions, 0 deletions
diff --git a/t/t0030-fast-pipe-response.sh b/t/t0030-fast-pipe-response.sh
new file mode 100755
index 0000000..5acbc01
--- /dev/null
+++ b/t/t0030-fast-pipe-response.sh
@@ -0,0 +1,36 @@
+#!/bin/sh
+. ./test-lib.sh
+test -r random_blob || die "random_blob required, run with 'make $0'"
+
+t_plan 6 "fast pipe response for $model"
+
+t_begin "setup and startup" && {
+        rtmpfiles err
+        rainbows_setup $model
+        rainbows -E none -D fast-pipe-response.ru -c $unicorn_config
+        rainbows_wait_start
+}
+
+t_begin "read random blob sha1" && {
+        random_blob_sha1=$(rsha1 < random_blob)
+}
+
+t_begin "single request matches" && {
+        sha1=$(curl -sSfv 2> $err http://$listen/ | rsha1)
+        test -n "$sha1"
+        test x"$sha1" = x"$random_blob_sha1"
+}
+
+t_begin "Content-Length header preserved in response" && {
+        grep "^< Content-Length:" $err
+}
+
+t_begin "shutdown server" && {
+        kill -QUIT $rainbows_pid
+}
+
+dbgcat r_err
+
+t_begin "check stderr" && check_stderr
+
+t_done